/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "fpd.y"

/*
 * fpd.y - FootPrint Definition language
 *
 * Written 2009 by Werner Almesberger
 * Copyright 2009 by Werner Almesberger
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#include <stdlib.h>
#include <string.h>

#include "util.h"
#include "error.h"
#include "expr.h"
#include "obj.h"
#include "meas.h"
#include "gui_status.h"
#include "fpd.h"


struct expr *expr_result;
const char *var_id;
struct value *var_value_list;


static struct frame *curr_frame;
static struct table *curr_table;
static struct row *curr_row;

static struct frame *last_frame = NULL;
static struct vec *last_vec = NULL;

static struct table **next_table;
static struct loop **next_loop;
static struct vec **next_vec;
static struct obj **next_obj;

static int n_vars, n_values;

static const char *id_sin, *id_cos, *id_sqrt;


static struct frame *find_frame(const char *name)
{
	struct frame *f;

	for (f = frames; f; f = f->next)
		if (f->name == name)
			return f;
	return NULL;
}


static struct vec *find_vec(const struct frame *frame, const char *name)
{
	struct vec *v;

	for (v = frame->vecs; v; v = v->next)
		if (v->name == name)
			return v;
	return NULL;
}


static void set_frame(struct frame *frame)
{
	curr_frame = frame;
	next_table = &frame->tables;
	next_loop = &frame->loops;
	next_vec = &frame->vecs;
	next_obj = &frame->objs;
	last_vec = NULL;
}


static void make_var(const char *id, struct expr *expr)
{
	struct table *table;

	table = zalloc_type(struct table);
	table->vars = zalloc_type(struct var);
	table->vars->name = id;
	table->vars->frame = curr_frame;
	table->vars->table = table;
	table->rows = zalloc_type(struct row);
	table->rows->table = table;
	table->rows->values = zalloc_type(struct value);
	table->rows->values->expr = expr;
	table->rows->values->row = table->rows;
	table->active_row = table->rows;
	*next_table = table;
	next_table = &table->next;
}


static void make_loop(const char *id, struct expr *from, struct expr *to)
{
	struct loop *loop;

	loop = alloc_type(struct loop);
	loop->var.name = id;
	loop->var.next = NULL;
	loop->var.frame = curr_frame;
	loop->var.table = NULL;
	loop->from.expr = from;
	loop->from.row = NULL;
	loop->from.next = NULL;
	loop->to.expr = to;
	loop->to.row = NULL;
	loop->to.next = NULL;
	loop->next = NULL;
	loop->active = 0;
	loop->initialized = 0;
	*next_loop = loop;
	next_loop = &loop->next;
}


static struct obj *new_obj(enum obj_type type)
{
	struct obj *obj;

	obj = alloc_type(struct obj);
	obj->type = type;
	obj->frame = curr_frame;
	obj->next = NULL;
	obj->lineno = lineno;
	return obj;
}




/* Line 268 of yacc.c  */
#line 211 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     START_FPD = 258,
     START_EXPR = 259,
     START_VAR = 260,
     START_VALUES = 261,
     TOK_SET = 262,
     TOK_LOOP = 263,
     TOK_PACKAGE = 264,
     TOK_FRAME = 265,
     TOK_TABLE = 266,
     TOK_VEC = 267,
     TOK_PAD = 268,
     TOK_RPAD = 269,
     TOK_RECT = 270,
     TOK_LINE = 271,
     TOK_CIRC = 272,
     TOK_ARC = 273,
     TOK_MEAS = 274,
     TOK_MEASX = 275,
     TOK_MEASY = 276,
     TOK_UNIT = 277,
     TOK_NEXT = 278,
     TOK_NEXT_INVERTED = 279,
     TOK_MAX = 280,
     TOK_MAX_INVERTED = 281,
     NUMBER = 282,
     STRING = 283,
     ID = 284,
     LABEL = 285
   };
#endif
/* Tokens.  */
#define START_FPD 258
#define START_EXPR 259
#define START_VAR 260
#define START_VALUES 261
#define TOK_SET 262
#define TOK_LOOP 263
#define TOK_PACKAGE 264
#define TOK_FRAME 265
#define TOK_TABLE 266
#define TOK_VEC 267
#define TOK_PAD 268
#define TOK_RPAD 269
#define TOK_RECT 270
#define TOK_LINE 271
#define TOK_CIRC 272
#define TOK_ARC 273
#define TOK_MEAS 274
#define TOK_MEASX 275
#define TOK_MEASY 276
#define TOK_UNIT 277
#define TOK_NEXT 278
#define TOK_NEXT_INVERTED 279
#define TOK_MAX 280
#define TOK_MAX_INVERTED 281
#define NUMBER 282
#define STRING 283
#define ID 284
#define LABEL 285




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 141 "fpd.y"

	struct num num;
	char *str;
	const char *id;
	struct expr *expr;
	struct frame *frame;
	struct table *table;
	struct var *var;
	struct row *row;
	struct value *value;
	struct vec *vec;
	struct obj *obj;
	enum pad_type pt;
	enum meas_type mt;
	struct {
		int inverted;
		int max;
	} mo;



/* Line 293 of yacc.c  */
#line 329 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 341 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  21
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   143

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  43
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  38
/* YYNRULES -- Number of rules.  */
#define YYNRULES  81
/* YYNRULES -- Number of states.  */
#define YYNSTATES  152

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   285

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      35,    36,    41,    39,    34,    40,    38,    42,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    33,     2,     2,    37,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,    32,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     4,     8,    11,    15,    18,    19,    24,
      27,    28,    31,    32,    35,    36,    43,    45,    48,    50,
      55,    62,    64,    67,    69,    70,    77,    79,    83,    85,
      86,    87,    88,    95,    97,   101,   103,   111,   113,   115,
     117,   123,   129,   134,   139,   144,   150,   151,   156,   157,
     159,   160,   163,   170,   172,   176,   178,   180,   182,   184,
     186,   188,   190,   191,   193,   194,   196,   198,   200,   204,
     208,   210,   214,   218,   220,   223,   225,   227,   229,   233,
     238,   239
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      44,     0,    -1,    -1,     3,    45,    46,    -1,     4,    75,
      -1,     5,    29,    80,    -1,     6,    61,    -1,    -1,    49,
      47,    48,    52,    -1,     9,    28,    -1,    -1,    22,    29,
      -1,    -1,    49,    50,    -1,    -1,    10,    29,    31,    51,
      52,    32,    -1,    68,    -1,    53,    52,    -1,    54,    -1,
       7,    29,    33,    75,    -1,     8,    29,    33,    75,    34,
      75,    -1,    63,    -1,    30,    63,    -1,    65,    -1,    -1,
      11,    55,    31,    56,    32,    58,    -1,    57,    -1,    56,
      34,    57,    -1,    29,    -1,    -1,    -1,    -1,    31,    59,
      61,    32,    60,    58,    -1,    62,    -1,    61,    34,    62,
      -1,    75,    -1,    12,    64,    35,    75,    34,    75,    36,
      -1,    37,    -1,    38,    -1,    29,    -1,    13,    28,    64,
      64,    67,    -1,    14,    28,    64,    64,    67,    -1,    15,
      64,    64,    74,    -1,    16,    64,    64,    74,    -1,    17,
      64,    64,    74,    -1,    18,    64,    64,    64,    74,    -1,
      -1,    10,    29,    66,    64,    -1,    -1,    29,    -1,    -1,
      68,    69,    -1,    71,    73,    70,    72,    70,    74,    -1,
      29,    -1,    29,    38,    29,    -1,    19,    -1,    20,    -1,
      21,    -1,    23,    -1,    24,    -1,    25,    -1,    26,    -1,
      -1,    28,    -1,    -1,    75,    -1,    76,    -1,    77,    -1,
      76,    39,    77,    -1,    76,    40,    77,    -1,    78,    -1,
      77,    41,    78,    -1,    77,    42,    78,    -1,    79,    -1,
      40,    79,    -1,    27,    -1,    29,    -1,    28,    -1,    35,
      75,    36,    -1,    29,    35,    75,    36,    -1,    -1,    33,
      61,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   188,   188,   187,   203,   207,   212,   218,   219,   223,
     240,   241,   256,   257,   262,   261,   284,   285,   289,   290,
     294,   298,   299,   307,   316,   315,   333,   337,   348,   361,
     365,   372,   364,   388,   392,   403,   414,   430,   434,   442,
     453,   462,   471,   478,   485,   493,   502,   501,   521,   524,
     539,   540,   548,   565,   573,   587,   591,   595,   602,   607,
     612,   617,   625,   628,   635,   638,   645,   652,   656,   660,
     667,   671,   675,   682,   686,   693,   698,   703,   708,   712,
     730,   733
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "START_FPD", "START_EXPR", "START_VAR",
  "START_VALUES", "TOK_SET", "TOK_LOOP", "TOK_PACKAGE", "TOK_FRAME",
  "TOK_TABLE", "TOK_VEC", "TOK_PAD", "TOK_RPAD", "TOK_RECT", "TOK_LINE",
  "TOK_CIRC", "TOK_ARC", "TOK_MEAS", "TOK_MEASX", "TOK_MEASY", "TOK_UNIT",
  "TOK_NEXT", "TOK_NEXT_INVERTED", "TOK_MAX", "TOK_MAX_INVERTED", "NUMBER",
  "STRING", "ID", "LABEL", "'{'", "'}'", "'='", "','", "'('", "')'", "'@'",
  "'.'", "'+'", "'-'", "'*'", "'/'", "$accept", "all", "$@1", "fpd",
  "part_name", "opt_unit", "frame_defs", "frame_def", "$@2", "frame_items",
  "frame_item", "table", "@3", "vars", "var", "rows", "@4", "$@5", "row",
  "value", "vec", "base", "obj", "@6", "pad_type", "measurements", "meas",
  "qbase", "meas_type", "meas_op", "opt_string", "opt_expr", "expr",
  "add_expr", "mult_expr", "unary_expr", "primary_expr", "opt_value_list", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   123,   125,    61,    44,    40,    41,    64,    46,    43,
      45,    42,    47
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    43,    45,    44,    44,    44,    44,    46,    46,    47,
      48,    48,    49,    49,    51,    50,    52,    52,    53,    53,
      53,    53,    53,    53,    55,    54,    56,    56,    57,    58,
      59,    60,    58,    61,    61,    62,    63,    64,    64,    64,
      65,    65,    65,    65,    65,    65,    66,    65,    67,    67,
      68,    68,    69,    70,    70,    71,    71,    71,    72,    72,
      72,    72,    73,    73,    74,    74,    75,    76,    76,    76,
      77,    77,    77,    78,    78,    79,    79,    79,    79,    79,
      80,    80
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     3,     2,     3,     2,     0,     4,     2,
       0,     2,     0,     2,     0,     6,     1,     2,     1,     4,
       6,     1,     2,     1,     0,     6,     1,     3,     1,     0,
       0,     0,     6,     1,     3,     1,     7,     1,     1,     1,
       5,     5,     4,     4,     4,     5,     0,     4,     0,     1,
       0,     2,     6,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     0,     1,     1,     1,     3,     3,
       1,     3,     3,     1,     2,     1,     1,     1,     3,     4,
       0,     2
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     2,     0,     0,     0,     0,    12,    75,    77,    76,
       0,     0,     4,    66,    67,    70,    73,    80,     6,    33,
      35,     1,     3,     0,     0,     0,    74,     0,     0,     0,
       0,     0,     5,     0,     0,     0,    10,    13,     0,    78,
      68,    69,    71,    72,    81,    34,     9,     0,     0,    50,
      79,    14,    11,     0,     0,     0,    24,     0,     0,     0,
       0,     0,     0,     0,     0,     8,    50,    18,    21,    23,
      16,    50,     0,     0,    46,     0,    39,    37,    38,     0,
       0,     0,     0,     0,     0,     0,    22,    17,    55,    56,
      57,    51,    62,     0,     0,     0,     0,     0,     0,     0,
       0,    64,    64,    64,     0,    63,     0,    15,    19,     0,
      47,    28,     0,    26,     0,    48,    48,    42,    65,    43,
      44,    64,    53,     0,     0,    29,     0,     0,    49,    40,
      41,    45,     0,    58,    59,    60,    61,     0,    20,    30,
      25,    27,     0,    54,    64,     0,    36,    52,     0,    31,
      29,    32
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,    22,    36,    49,    23,    37,    71,    65,
      66,    67,    75,   112,   113,   140,   145,   150,    18,    19,
      68,    79,    69,    96,   129,    70,    91,   123,    92,   137,
     106,   117,   118,    13,    14,    15,    16,    32
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -92
static const yytype_int8 yypact[] =
{
      60,   -92,     5,   -15,     5,    17,    35,   -92,   -92,     6,
       5,     9,   -92,    10,   -32,   -92,   -92,    34,    38,   -92,
     -92,   -92,   -92,    67,     5,    47,   -92,     5,     5,     5,
       5,     5,   -92,     5,    56,    57,    58,   -92,    49,   -92,
     -32,   -32,   -92,   -92,    38,   -92,   -92,    59,    62,    44,
     -92,   -92,   -92,    65,    66,    68,   -92,   -22,    61,    70,
     -22,   -22,   -22,   -22,    75,   -92,    44,   -92,   -92,   -92,
       0,    44,    55,    69,   -92,    72,   -92,   -92,   -92,    64,
     -22,   -22,   -22,   -22,   -22,   -22,   -92,   -92,   -92,   -92,
     -92,   -92,    73,    74,     5,     5,   -22,    71,     5,   -22,
     -22,     5,     5,     5,   -22,   -92,    76,   -92,   -92,    77,
     -92,   -92,    14,   -92,    78,    79,    79,   -92,   -92,   -92,
     -92,     5,    80,    45,     5,    82,    71,     5,   -92,   -92,
     -92,   -92,    81,   -92,   -92,   -92,   -92,    76,   -92,   -92,
     -92,   -92,    83,   -92,     5,     5,   -92,   -92,    41,   -92,
      82,   -92
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -53,
     -92,   -92,   -92,   -92,   -19,   -46,   -92,   -92,   -30,    84,
      50,   -57,   -92,   -92,    -7,   -92,   -92,   -21,   -92,   -92,
     -92,   -91,    -2,   -92,    51,    52,   109,   -92
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -8
static const yytype_int16 yytable[] =
{
      12,    44,    20,    82,    83,    84,    85,    76,    25,    29,
      30,   119,   120,    87,    17,    77,    78,    21,    93,    88,
      89,    90,    38,    99,   100,   101,   102,   103,   104,    20,
     131,    20,     7,     8,     9,    -7,     7,     8,     9,   110,
      10,    24,   115,   116,    10,    11,   125,   121,   126,    27,
      28,    53,    54,   147,    55,    56,    57,    58,    59,    60,
      61,    62,    63,     1,     2,     3,     4,    31,   133,   134,
     135,   136,    33,   149,    64,    33,    34,    35,    40,    41,
      48,    42,    43,    39,    46,    50,    47,    57,    94,    80,
      51,    52,   108,   109,    72,    73,   114,    74,    81,    98,
     111,   105,    95,    97,   151,   122,   107,   141,   128,   130,
     143,   124,   127,   139,    86,   148,   144,    45,   132,   146,
      26,     0,   138,     0,     0,   142,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-92))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       2,    31,     4,    60,    61,    62,    63,    29,    10,    41,
      42,   102,   103,    66,    29,    37,    38,     0,    71,    19,
      20,    21,    24,    80,    81,    82,    83,    84,    85,    31,
     121,    33,    27,    28,    29,     0,    27,    28,    29,    96,
      35,    35,    99,   100,    35,    40,    32,   104,    34,    39,
      40,     7,     8,   144,    10,    11,    12,    13,    14,    15,
      16,    17,    18,     3,     4,     5,     6,    33,    23,    24,
      25,    26,    34,    32,    30,    34,     9,    10,    27,    28,
      22,    29,    30,    36,    28,    36,    29,    12,    33,    28,
      31,    29,    94,    95,    29,    29,    98,    29,    28,    35,
      29,    28,    33,    31,   150,    29,    32,   126,    29,   116,
      29,    34,    34,    31,    64,   145,   137,    33,    38,    36,
      11,    -1,   124,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   145
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,    44,    45,    27,    28,    29,
      35,    40,    75,    76,    77,    78,    79,    29,    61,    62,
      75,     0,    46,    49,    35,    75,    79,    39,    40,    41,
      42,    33,    80,    34,     9,    10,    47,    50,    75,    36,
      77,    77,    78,    78,    61,    62,    28,    29,    22,    48,
      36,    31,    29,     7,     8,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    30,    52,    53,    54,    63,    65,
      68,    51,    29,    29,    29,    55,    29,    37,    38,    64,
      28,    28,    64,    64,    64,    64,    63,    52,    19,    20,
      21,    69,    71,    52,    33,    33,    66,    31,    35,    64,
      64,    64,    64,    64,    64,    28,    73,    32,    75,    75,
      64,    29,    56,    57,    75,    64,    64,    74,    75,    74,
      74,    64,    29,    70,    34,    32,    34,    34,    29,    67,
      67,    74,    38,    23,    24,    25,    26,    72,    75,    31,
      58,    57,    75,    29,    70,    59,    36,    74,    61,    32,
      60,    58
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 188 "fpd.y"
    {
			root_frame = zalloc_type(struct frame);
			set_frame(root_frame);
			id_sin = unique("sin");
			id_cos = unique("cos");
			id_sqrt = unique("sqrt");
		}
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 196 "fpd.y"
    {
			root_frame->prev = last_frame;
			if (last_frame)
				last_frame->next = root_frame;
			else
				frames = root_frame;
		}
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 204 "fpd.y"
    {
			expr_result = (yyvsp[(2) - (2)].expr);
		}
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 208 "fpd.y"
    {
			var_id = (yyvsp[(2) - (3)].id);
			var_value_list = (yyvsp[(3) - (3)].value);
		}
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 213 "fpd.y"
    {
			var_value_list = (yyvsp[(2) - (2)].value);
		}
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 224 "fpd.y"
    {
			const char *p;

			if (!*(yyvsp[(2) - (2)].str)) {
				yyerrorf("invalid package name");
				YYABORT;
			}
			for (p = (yyvsp[(2) - (2)].str); *p; *p++)
				if (*p < 32 || *p > 126) {
					yyerrorf("invalid package name");
					YYABORT;
				}
			pkg_name = (yyvsp[(2) - (2)].str);
		}
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 242 "fpd.y"
    {
			if (!strcmp((yyvsp[(2) - (2)].id), "mm"))
				curr_unit = curr_unit_mm;
			else if (!strcmp((yyvsp[(2) - (2)].id), "mil"))
				curr_unit = curr_unit_mil;
			else if (!strcmp((yyvsp[(2) - (2)].id), "auto"))
				curr_unit = curr_unit_auto;
			else {
				yyerrorf("unrecognized unit \"%s\"", (yyvsp[(2) - (2)].id));
				YYABORT;
			}
		}
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 262 "fpd.y"
    {
			if (find_frame((yyvsp[(2) - (3)].id))) {
				yyerrorf("duplicate frame \"%s\"", (yyvsp[(2) - (3)].id));
				YYABORT;
			}
			curr_frame = zalloc_type(struct frame);
			curr_frame->name = (yyvsp[(2) - (3)].id);
			set_frame(curr_frame);
			curr_frame->prev = last_frame;
			if (last_frame)
				last_frame->next = curr_frame;
			else
				frames = curr_frame;
			last_frame = curr_frame;
		}
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 278 "fpd.y"
    {
			set_frame(root_frame);
		}
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 291 "fpd.y"
    {
			make_var((yyvsp[(2) - (4)].id), (yyvsp[(4) - (4)].expr));
		}
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 295 "fpd.y"
    {
			make_loop((yyvsp[(2) - (6)].id), (yyvsp[(4) - (6)].expr), (yyvsp[(6) - (6)].expr));
		}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 300 "fpd.y"
    {
			if (find_vec(curr_frame, (yyvsp[(1) - (2)].id))) {
				yyerrorf("duplicate vector \"%s\"", (yyvsp[(1) - (2)].id));
				YYABORT;
			}
			(yyvsp[(2) - (2)].vec)->name = (yyvsp[(1) - (2)].id);
		}
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 308 "fpd.y"
    {
			*next_obj = (yyvsp[(1) - (1)].obj);
			next_obj = &(yyvsp[(1) - (1)].obj)->next;
		}
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 316 "fpd.y"
    {
			(yyval.table) = zalloc_type(struct table);
			*next_table = (yyval.table);
			curr_table = (yyval.table);
			n_vars = 0;
		}
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 323 "fpd.y"
    {
			(yyval.table) = (yyvsp[(2) - (6)].table);
			(yyval.table)->vars = (yyvsp[(4) - (6)].var);
			(yyval.table)->rows = (yyvsp[(6) - (6)].row);
			(yyval.table)->active_row = (yyvsp[(6) - (6)].row);
			next_table = &(yyval.table)->next;
		}
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 334 "fpd.y"
    {
			(yyval.var) = (yyvsp[(1) - (1)].var);
		}
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 338 "fpd.y"
    {
			struct var **walk;

			(yyval.var) = (yyvsp[(1) - (3)].var);
			for (walk = &(yyval.var); *walk; walk = &(*walk)->next);
			*walk = (yyvsp[(3) - (3)].var);
		}
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 349 "fpd.y"
    {
			(yyval.var) = zalloc_type(struct var);
			(yyval.var)->name = (yyvsp[(1) - (1)].id);
			(yyval.var)->frame = curr_frame;
			(yyval.var)->table = curr_table;
			(yyval.var)->next = NULL;
			n_vars++;
		}
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 361 "fpd.y"
    {
			(yyval.row) = NULL;
		}
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 365 "fpd.y"
    {
			(yyval.row) = alloc_type(struct row);
			(yyval.row)->table = curr_table;
			curr_row = (yyval.row);;
			n_values = 0;
		}
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 372 "fpd.y"
    {
			if (n_vars != n_values) {
				yyerrorf("table has %d variables but row has "
				    "%d values", n_vars, n_values);
				YYABORT;
			}
			(yyvsp[(2) - (4)].row)->values = (yyvsp[(3) - (4)].value);
		}
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 381 "fpd.y"
    {
			(yyval.row) = (yyvsp[(2) - (6)].row);
			(yyval.row)->next = (yyvsp[(6) - (6)].row);
		}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 389 "fpd.y"
    {
			(yyval.value) = (yyvsp[(1) - (1)].value);
		}
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 393 "fpd.y"
    {
			struct value **walk;

			(yyval.value) = (yyvsp[(1) - (3)].value);
			for (walk = &(yyval.value); *walk; walk = &(*walk)->next);
			*walk = (yyvsp[(3) - (3)].value);
		}
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 404 "fpd.y"
    {
			(yyval.value) = alloc_type(struct value);
			(yyval.value)->expr = (yyvsp[(1) - (1)].expr);
			(yyval.value)->row = curr_row;
			(yyval.value)->next = NULL;
			n_values++;
		}
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 415 "fpd.y"
    {
			(yyval.vec) = alloc_type(struct vec);
			(yyval.vec)->name = NULL;
			(yyval.vec)->base = (yyvsp[(2) - (7)].vec);
			(yyval.vec)->x = (yyvsp[(4) - (7)].expr);
			(yyval.vec)->y = (yyvsp[(6) - (7)].expr);
			(yyval.vec)->frame = curr_frame;
			(yyval.vec)->next = NULL;
			last_vec = (yyval.vec);
			*next_vec = (yyval.vec);
			next_vec = &(yyval.vec)->next;
		}
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 431 "fpd.y"
    {
			(yyval.vec) = NULL;
		}
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 435 "fpd.y"
    {
			(yyval.vec) = last_vec;
			if (!(yyval.vec)) {
				yyerrorf(". without predecessor");
				YYABORT;
			}
		}
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 443 "fpd.y"
    {
			(yyval.vec) = find_vec(curr_frame, (yyvsp[(1) - (1)].id));
			if (!(yyval.vec)) {
				yyerrorf("unknown vector \"%s\"", (yyvsp[(1) - (1)].id));
				YYABORT;
			}
		}
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 454 "fpd.y"
    {
			(yyval.obj) = new_obj(ot_pad);
			(yyval.obj)->base = (yyvsp[(3) - (5)].vec);
			(yyval.obj)->u.pad.name = (yyvsp[(2) - (5)].str);
			(yyval.obj)->u.pad.other = (yyvsp[(4) - (5)].vec);
			(yyval.obj)->u.pad.rounded = 0;
			(yyval.obj)->u.pad.type = (yyvsp[(5) - (5)].pt);
		}
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 463 "fpd.y"
    {
			(yyval.obj) = new_obj(ot_pad);
			(yyval.obj)->base = (yyvsp[(3) - (5)].vec);
			(yyval.obj)->u.pad.name = (yyvsp[(2) - (5)].str);
			(yyval.obj)->u.pad.other = (yyvsp[(4) - (5)].vec);
			(yyval.obj)->u.pad.rounded = 1;
			(yyval.obj)->u.pad.type = (yyvsp[(5) - (5)].pt);
		}
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 472 "fpd.y"
    {
			(yyval.obj) = new_obj(ot_rect);
			(yyval.obj)->base = (yyvsp[(2) - (4)].vec);
			(yyval.obj)->u.rect.other = (yyvsp[(3) - (4)].vec);
			(yyval.obj)->u.rect.width = (yyvsp[(4) - (4)].expr);
		}
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 479 "fpd.y"
    {
			(yyval.obj) = new_obj(ot_line);
			(yyval.obj)->base = (yyvsp[(2) - (4)].vec);
			(yyval.obj)->u.line.other = (yyvsp[(3) - (4)].vec);
			(yyval.obj)->u.line.width = (yyvsp[(4) - (4)].expr);
		}
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 486 "fpd.y"
    {
			(yyval.obj) = new_obj(ot_arc);
			(yyval.obj)->base = (yyvsp[(2) - (4)].vec);
			(yyval.obj)->u.arc.start = (yyvsp[(3) - (4)].vec);
			(yyval.obj)->u.arc.end = (yyvsp[(3) - (4)].vec);
			(yyval.obj)->u.arc.width = (yyvsp[(4) - (4)].expr);
		}
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 494 "fpd.y"
    {
			(yyval.obj) = new_obj(ot_arc);
			(yyval.obj)->base = (yyvsp[(2) - (5)].vec);
			(yyval.obj)->u.arc.start = (yyvsp[(3) - (5)].vec);
			(yyval.obj)->u.arc.end = (yyvsp[(4) - (5)].vec);
			(yyval.obj)->u.arc.width = (yyvsp[(5) - (5)].expr);
		}
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 502 "fpd.y"
    { 
		    (yyval.num).n = lineno;
		}
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 506 "fpd.y"
    {
			(yyval.obj) = new_obj(ot_frame);
			(yyval.obj)->base = (yyvsp[(4) - (4)].vec);
			(yyval.obj)->u.frame.ref = find_frame((yyvsp[(2) - (4)].id));
			if (!(yyval.obj)->u.frame.ref) {
				yyerrorf("unknown frame \"%s\"", (yyvsp[(2) - (4)].id));
				YYABORT;
			}
			if (!(yyval.obj)->u.frame.ref->active_ref)
				(yyval.obj)->u.frame.ref->active_ref = (yyval.obj);
			(yyval.obj)->u.frame.lineno = (yyvsp[(3) - (4)].num).n;
		}
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 521 "fpd.y"
    {
			(yyval.pt) = pt_normal;
		}
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 525 "fpd.y"
    {
			if (!strcmp((yyvsp[(1) - (1)].id), "bare"))
				(yyval.pt) = pt_bare;
			else if (!strcmp((yyvsp[(1) - (1)].id), "paste"))
				(yyval.pt) = pt_paste;
			else if (!strcmp((yyvsp[(1) - (1)].id), "mask"))
				(yyval.pt) = pt_mask;
			else {
				yyerrorf("unknown pad type \"%s\"", (yyvsp[(1) - (1)].id));
				YYABORT;
			}
		}
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 541 "fpd.y"
    {
			*next_obj = (yyvsp[(2) - (2)].obj);
			next_obj = &(yyvsp[(2) - (2)].obj)->next;
		}
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 549 "fpd.y"
    {
			struct meas *meas;

			(yyval.obj) = new_obj(ot_meas);
			meas = &(yyval.obj)->u.meas;
			meas->type = (yyvsp[(4) - (6)].mo).max ? (yyvsp[(1) - (6)].mt)+3 : (yyvsp[(1) - (6)].mt);
			meas->label = (yyvsp[(2) - (6)].str);
			(yyval.obj)->base = (yyvsp[(3) - (6)].vec);
			meas->inverted = (yyvsp[(4) - (6)].mo).inverted;
			meas->high = (yyvsp[(5) - (6)].vec);
			meas->offset = (yyvsp[(6) - (6)].expr);
			(yyval.obj)->next = NULL;
		}
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 566 "fpd.y"
    {
			(yyval.vec) = find_vec(root_frame, (yyvsp[(1) - (1)].id));
			if (!(yyval.vec)) {
				yyerrorf("unknown vector \"%s\"", (yyvsp[(1) - (1)].id));
				YYABORT;
			}
		}
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 574 "fpd.y"
    {
			const struct frame *frame;

			frame = find_frame((yyvsp[(1) - (3)].id));
			(yyval.vec) = frame ? find_vec(frame, (yyvsp[(3) - (3)].id)) : NULL;
			if (!(yyval.vec)) {
				yyerrorf("unknown vector \"%s.%s\"", (yyvsp[(1) - (3)].id), (yyvsp[(3) - (3)].id));
				YYABORT;
			}
		}
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 588 "fpd.y"
    {
			(yyval.mt) = mt_xy_next;
		}
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 592 "fpd.y"
    {
			(yyval.mt) = mt_x_next;
		}
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 596 "fpd.y"
    {
			(yyval.mt) = mt_y_next;
		}
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 603 "fpd.y"
    {
			(yyval.mo).max = 0;
			(yyval.mo).inverted = 0;
		}
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 608 "fpd.y"
    {
			(yyval.mo).max = 0;
			(yyval.mo).inverted = 1;
		}
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 613 "fpd.y"
    {
			(yyval.mo).max = 1;
			(yyval.mo).inverted = 0;
		}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 618 "fpd.y"
    {
			(yyval.mo).max = 1;
			(yyval.mo).inverted = 1;
		}
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 625 "fpd.y"
    {
			(yyval.str) = NULL;
		}
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 629 "fpd.y"
    {
			(yyval.str) = (yyvsp[(1) - (1)].str);
		}
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 635 "fpd.y"
    {
			(yyval.expr) = NULL;
		}
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 639 "fpd.y"
    {
			(yyval.expr) = (yyvsp[(1) - (1)].expr);
		}
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 646 "fpd.y"
    {
			(yyval.expr) = (yyvsp[(1) - (1)].expr);
		}
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 653 "fpd.y"
    {
			(yyval.expr) = (yyvsp[(1) - (1)].expr);
		}
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 657 "fpd.y"
    {
			(yyval.expr) = binary_op(op_add, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		}
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 661 "fpd.y"
    {
			(yyval.expr) = binary_op(op_sub, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		}
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 668 "fpd.y"
    {
			(yyval.expr) = (yyvsp[(1) - (1)].expr);
		}
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 672 "fpd.y"
    {
			(yyval.expr) = binary_op(op_mult, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		}
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 676 "fpd.y"
    {
			(yyval.expr) = binary_op(op_div, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		}
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 683 "fpd.y"
    {
			(yyval.expr) = (yyvsp[(1) - (1)].expr);
		}
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 687 "fpd.y"
    {
			(yyval.expr) = binary_op(op_minus, (yyvsp[(2) - (2)].expr), NULL);
		}
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 694 "fpd.y"
    {
			(yyval.expr) = new_op(op_num);
			(yyval.expr)->u.num = (yyvsp[(1) - (1)].num);
		}
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 699 "fpd.y"
    {
			(yyval.expr) = new_op(op_var);
			(yyval.expr)->u.var = (yyvsp[(1) - (1)].id);
		}
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 704 "fpd.y"
    {
			(yyval.expr) = new_op(op_string);
			(yyval.expr)->u.str = (yyvsp[(1) - (1)].str);
		}
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 709 "fpd.y"
    {
			(yyval.expr) = (yyvsp[(2) - (3)].expr);
		}
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 713 "fpd.y"
    {
			if ((yyvsp[(1) - (4)].id) == id_sin)
				(yyval.expr) = binary_op(op_sin, (yyvsp[(3) - (4)].expr), NULL);
			else if ((yyvsp[(1) - (4)].id) == id_cos)
				(yyval.expr) = binary_op(op_cos, (yyvsp[(3) - (4)].expr), NULL);
			else if ((yyvsp[(1) - (4)].id) == id_sqrt)
				(yyval.expr) = binary_op(op_sqrt, (yyvsp[(3) - (4)].expr), NULL);
			else {
				yyerrorf("unknown function \"%s\"", (yyvsp[(1) - (4)].id));
				YYABORT;
			}
		}
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 730 "fpd.y"
    {
			(yyval.value) = NULL;
		}
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 734 "fpd.y"
    {
			(yyval.value) = (yyvsp[(2) - (2)].value);
		}
    break;



/* Line 1806 of yacc.c  */
#line 2508 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



